/*
 * defs.h
 *
 * Created: 2016-04-27 14:11:42
 *  Author: dsosnowski
 */ 


#ifndef DEFS_H_
#define DEFS_H_

#define F_CPU 8000000UL

#define EXTREME_PORT		PORTB
#define EXTREME_PIN			PINB
#define EXT1_PIN			1		//PCINT9
#define EXT2_PIN			0		//PCINT8
#define EXT1_GET			(PINB & (1<<EXT1_PIN))
#define EXT2_GET			(PINB & (1<<EXT2_PIN))

#define RELAY_PORT			PORTB
#define RELAY_DDR			DDRB
#define REL_PIN				2
#define REL_SET				(RELAY_PORT |= (1<<REL_PIN))
#define REL_OFF				(RELAY_PORT &=~(1<<REL_PIN))

#define DRIVE_PORT			PORTA
#define DRIVE_DDR			DDRA
#define DRV_PIN				5		//OC1B, active H

#define LED_PORT			PORTA
#define LED_DDR				DDRA		
#define LED_PIN				2		//active H
#define LED_SET				(LED_PORT |= (1<<LED_PIN))
#define LED_OFF				(LED_PORT &=~(1<<LED_PIN))

#define SENSE_PORT			PORTA
#define SENSE_PIN			6
#define SENSE_GND_PIN		7	
#define SENSE_CH			6
#define SENSE_GND_CH		7

#define REG_PORT			PORTA
#define REG_PIN				3
#define REG_CH				3
		
#define TRIM_PORT			PORTA
#define TRIM1_PIN			1
#define TRIM_CURR_CH		1
#define TRIM2_PIN			4
#define TRIM_TIME_CH		4


#define REG_MIN_L			20
#define REG_MIN_H			120
#define REG_MIN_TH			133

#define REG_MAX_TH			123
#define REG_MAX_L			135
#define REG_MAX_H			235




#endif /* DEFS_H_ */