/*
 * power.c
 *
 * Created: 2016-04-28 12:00:21
 *  Author: dsosnowski
 */ 



#include <avr/io.h>
#include "defs.h"
#include <avr/interrupt.h>
#include <inttypes.h>
#include <util/delay.h>
#include <avr/wdt.h>
#include <avr/sleep.h>
#include "power.h"




//-----------------------------------------------------------------------


struct {
	char value;
	volatile char actual;
} power;


//-----------------------------------------------------------------------
void PowerInit(void){
	RELAY_PORT &= ~(1<<REL_PIN);
	RELAY_DDR |= (1<<REL_PIN);

	DRIVE_PORT &= ~(1<<DRV_PIN);
	DRIVE_DDR |= (1<<DRV_PIN); 

	TIMSK1 = (1<<TOIE1);
	
	ICR1 = PWM_RESOLUTION;
	OCR1B = PWM_OFF_VALUE;
	TCCR1A = (1<<WGM11 | 0<<WGM10);
	TCCR1B = (1<<WGM12 | 1<<WGM13 | 1<<CS12 | 0<<CS10);
}

//-----------------------------------------------------------------------
void PowerSetValue(char val){
	power.value = val;
}

//-----------------------------------------------------------------------
char PowerGetActual(void){
	return power.actual;
}

//-----------------------------------------------------------------------
ISR (TIM1_OVF_vect) {
	static char delay;
		
	if (delay < PWM_DELAY) 
		delay++;
	else {
		delay = 0;
		if (power.actual < power.value) power.actual++;
	}

	if (power.actual > power.value) power.actual = power.value;
	if (power.actual > (PWM_MAX - PWM_FILTER)) power.actual = PWM_MAX;
	
	if (power.actual < PWM_MIN) {
		TCCR1A = (1<<WGM11 | 0<<WGM10);
	} else {
		OCR1B = power.actual;
		TCCR1A = (1<<WGM11 | 0<<WGM10 | 1<<COM1B1 | 0<<COM1B0);	
	}
}
